/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.40 from the
 * contents of UserSettings.xxs. Do not edit this file, edit UserSettings.xxs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/UserSettings.xxs"
/* Copyright (c) 1997-2021
   Ewgenij Gawrilow, Michael Joswig, and the polymake team
   Technische Universität Berlin, Germany
   https://polymake.org

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
*/

#include "polymake/perl/glue.h"

namespace pm { namespace perl { namespace glue {
namespace {

int Item_flags_index, Item_custom_flag, Item_changed_flag, Settings_changed_index;

bool is_local_change(pTHX)
{
   if (PL_localizing)
      return true;
   switch (PL_op->op_type) {
   case OP_AELEM:
   case OP_DELETE:
   case OP_POP:
   case OP_SHIFT:
#if PerlVersion >= 5220
   case OP_MULTIDEREF:
#endif
      return PL_op->op_private & OPpLVAL_INTRO;
   case OP_LEAVE:
   case OP_LEAVESUB:
   case OP_LEAVESUBLV:
   case OP_LEAVEEVAL:
   case OP_LEAVELOOP:
      return true;
   }
   return false;
}

int set_changed_flag(pTHX_ SV *sv, MAGIC* mg)
{
   if (!is_local_change(aTHX)) {
      SV* item_flags_sv = AvARRAY(SvRV(mg->mg_obj))[Item_flags_index];
      IV flags = SvIV(item_flags_sv);
      flags |= Item_custom_flag | Item_changed_flag;
      sv_setiv(item_flags_sv, flags);
      SV* settings_sv = AvARRAY((SV*)mg->mg_ptr)[Settings_changed_index];
      sv_setiv(settings_sv, 1);
   }
   return 0;
}

void add_change_monitor(pTHX_ SV* sv, SV* item, SV* self);

int copy_change_monitor(pTHX_ SV*, MAGIC* mg, SV* nsv, const char*, mg_copy_index_t)
{
   add_change_monitor(aTHX_ nsv, mg->mg_obj, (SV*)mg->mg_ptr);
   return 0;
}

int no_local_monitor(pTHX_ SV*, MAGIC*)
{
   return 0;
}

MGVTBL change_monitor_vtbl{
   nullptr, &set_changed_flag, nullptr, &set_changed_flag, nullptr,
   &copy_change_monitor, &monitored_dup, &no_local_monitor };

void add_change_monitor(pTHX_ AV* av, SV* item, SV* self)
{
   const SSize_t last = AvFILLp(av);
   if (last >= 0) {
      for (SV **svp = AvARRAY(av), **lastp = svp + last;  svp <= lastp;  ++svp) {
         SV* elem = *svp;
         if (elem)
            add_change_monitor(aTHX_ elem, item, self);
      }
   }
}

void add_change_monitor(pTHX_ HV* hv, SV* item, SV* self)
{
   if (hv_iterinit(hv)) {
      while (HE* he = hv_iternext(hv)) {
         SV* val = HeVAL(he);
         add_change_monitor(aTHX_ val, item, self);
      }
   }
}

void add_change_monitor(pTHX_ SV* sv, SV* item, SV* self)
{
   if (SvROK(sv)) {
      SV* target = SvRV(sv);
      if (!SvOBJECT(target)) {
         if (SvTYPE(target) == SVt_PVAV) {
            add_change_monitor(aTHX_ (AV*)target, item, self);
            sv = target;
         } else if (SvTYPE(target) == SVt_PVHV) {
            add_change_monitor(aTHX_ (HV*)target, item, self);
            sv = target;
         } else if (SvTYPE(target) <= SVt_PVMG) {
            sv = target;
         }
      }
   }
   MAGIC* mg = sv_magicext(sv, item, PERL_MAGIC_ext, &change_monitor_vtbl, (char*)self, 0);
   mg->mg_flags |= MGf_LOCAL;
}

bool deserves_reset(pTHX_ MAGIC* mg)
{
   SV* item_flags_sv = AvARRAY(SvRV(mg->mg_obj))[Item_flags_index];
   IV flags = SvIV(item_flags_sv);
   if (flags & Item_custom_flag) {
      flags &= ~Item_custom_flag;
      flags |= Item_changed_flag;
      sv_setiv(item_flags_sv, flags);
      SV* settings_sv = AvARRAY((SV*)mg->mg_ptr)[Settings_changed_index];
      sv_setiv(settings_sv, 1);
      return true;
   }
   return false;
}

bool reset_custom_var(pTHX_ SV* sv, SV** SP, I32 sp_offset = 0)
{
   MAGIC* mg;
   if (!SvSMAGICAL(sv) || !(mg = get_monitored_magic(sv)))
      return false;
   if (deserves_reset(aTHX_ mg)) {
      PUSHMARK(SP + sp_offset - 1);
      SP[sp_offset] = mg->mg_obj;
      mg->mg_virtual = nullptr;
      Perl_call_method(aTHX_ "reset_value", G_VOID | G_DISCARD);
      mg->mg_virtual = &change_monitor_vtbl;
   }
   return true;
}

OP* reset_custom_sv(pTHX)
{
   dSP;
   SV* sv = TOPs;
   if (!sv || SvTYPE(sv) < SVt_PVMG || !reset_custom_var(aTHX_ sv, SP))
      DIE(aTHX_ "not a custom variable");
   return NORMAL;
}

OP* reset_custom_helem(pTHX)
{
   dSP;
   SV* hv = TOPm1s;
   if (!reset_custom_var(aTHX_ hv, SP, -1))
      DIE(aTHX_ "not a custom hash element");
   return NORMAL;
}

OP* reset_custom_hslice(pTHX)
{
   dSP;
   SV* hv = TOPs;
   MAGIC* mg;
   if (SvSMAGICAL(hv) && (mg = get_monitored_magic(hv))) {
      SV** firstkey = PL_stack_base+TOPMARK+1;
      if (firstkey < SP && deserves_reset(aTHX_ mg)) {
         // the order of keys does not play any role, can be permuted to avoid full move
         SP[0] = *firstkey;
         *firstkey = mg->mg_obj;
         mg->mg_virtual = nullptr;
         Perl_call_method(aTHX_ "reset_value", G_VOID | G_DISCARD);
         mg->mg_virtual = &change_monitor_vtbl;
      } else {
         dMARK;
         SP = MARK;
         PUTBACK;
      }
      return NORMAL;
   }
   DIE(aTHX_ "not a custom hash element");
}

OP* prepare_reset_custom(pTHX_ OP* o)
{
   OP* gvop = cUNOPo->op_first;
   if (gvop->op_type != OP_GV) {
      report_parse_error("wrong use of reset_custom; expecting plain package variable");
      return nullptr;
   }
   o->op_flags |= OPf_REF;
   OP* full_op = newUNOP(OP_NULL, OPf_WANT_VOID, o);
   full_op->op_type = OP_CUSTOM;
   full_op->op_ppaddr = reset_custom_sv;
   return full_op;
}

OP* prepare_reset_custom_helem(pTHX_ OP* o)
{
   OP* rvop = cUNOPo->op_first;
   if (rvop->op_type != OP_RV2HV || cUNOPx(rvop)->op_first->op_type != OP_GV) {
      report_parse_error("wrong use of reset_custom; expecting plain package variable");
      return nullptr;
   }
   o->op_type = OP_CUSTOM;
   o->op_ppaddr = &reset_custom_helem;
   clear_bit_flags(o->op_flags, OPf_WANT);
   set_bit_flags(o->op_flags, OPf_WANT_VOID);
   return o;
}

OP* prepare_reset_custom_hslice(pTHX_ OP* o)
{
   OP* rvop = cLISTOPo->op_last;
   if (rvop->op_type != OP_RV2HV || cUNOPx(rvop)->op_first->op_type != OP_GV) {
      report_parse_error("wrong use of reset_custom; expecting plain package variable");
      return KEYWORD_PLUGIN_DECLINE;
   }
   o->op_type = OP_CUSTOM;
   o->op_ppaddr = &reset_custom_hslice;
   clear_bit_flags(o->op_flags, OPf_WANT);
   set_bit_flags(o->op_flags, OPf_WANT_VOID);
   return o;
}

}

int monitored_dup(pTHX_ MAGIC* mg, CLONE_PARAMS* param)
{
   return 0;
}

int parse_set_custom(pTHX_ OP** op_ptr)
{
   op_keeper<OP> o(aTHX_ parse_termexpr(0));
   if (o) {
      if (o->op_type == OP_SASSIGN || o->op_type == OP_AASSIGN) {
         *op_ptr = o.release();
         return KEYWORD_PLUGIN_EXPR;
      }
      report_parse_error("set_custom can only be combined with an assignment");
   }
   return KEYWORD_PLUGIN_DECLINE;
}

int parse_reset_custom(pTHX_ OP** op_ptr)
{
   op_keeper<OP> o(aTHX_ parse_termexpr(0));
   if (o) {
      OP* full_op = nullptr;
      switch (o->op_type) {
      case OP_RV2SV:
         full_op = prepare_reset_custom(aTHX_ o);
         break;
      case OP_RV2AV:
         full_op = prepare_reset_custom(aTHX_ o);
         break;
      case OP_RV2HV:
         full_op = prepare_reset_custom(aTHX_ o);
         break;
      case OP_HELEM:
         full_op = prepare_reset_custom_helem(aTHX_ o);
         break;
      case OP_HSLICE:
         full_op = prepare_reset_custom_hslice(aTHX_ o);
         break;
      default:
         report_parse_error("reset_custom is only applicable to scalar, array, hash variables, or hash elements/slices");
         break;
      }
      if (full_op) {
         *op_ptr = full_op;
         o.release();
         return KEYWORD_PLUGIN_STMT;
      }
   }
   return KEYWORD_PLUGIN_DECLINE;
}

} } }

using namespace pm::perl::glue;

#line 302 "/builddir/build/BUILD/polymake-4.4/build.x86_64/perlx/5.32.1/x86_64-linux-thread-multi/UserSettings.cc"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 446 "/builddir/build/BUILD/polymake-4.4/build.x86_64/perlx/5.32.1/x86_64-linux-thread-multi/UserSettings.cc"

XS_EUPXS(XS_Polymake__Core__UserSettings_add_change_monitor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Polymake__Core__UserSettings_add_change_monitor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, item, ref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	SV *	item = ST(1)
;
	SV *	ref = ST(2)
;
#line 298 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/UserSettings.xxs"
{
   if (!SvROK(ref) || !(SvROK(item) && SvOBJECT(SvRV(item))) ||
       !(SvROK(self) && (self = SvRV(self), SvOBJECT(self))))
      croak_xs_usage(cv, "UserSettings, Item, \\data");
   add_change_monitor(aTHX_ ref, item, self);
}
#line 470 "/builddir/build/BUILD/polymake-4.4/build.x86_64/perlx/5.32.1/x86_64-linux-thread-multi/UserSettings.cc"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Polymake__Core__UserSettings_drop_change_monitor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Polymake__Core__UserSettings_drop_change_monitor)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ref = ST(0)
;
#line 307 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/UserSettings.xxs"
{
   if (!SvROK(ref))
      croak_xs_usage(cv, "\\data");
   mg_free_type(SvRV(ref), PERL_MAGIC_ext);
}
#line 494 "/builddir/build/BUILD/polymake-4.4/build.x86_64/perlx/5.32.1/x86_64-linux-thread-multi/UserSettings.cc"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Polymake__Core__UserSettings_get_item); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Polymake__Core__UserSettings_get_item)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ref = ST(0)
;
#line 315 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/UserSettings.xxs"
{
   if (!SvROK(ref))
      croak_xs_usage(cv, "\\data");
   if (MAGIC* mg = get_monitored_magic(SvRV(ref))) {
      PUSHs(mg->mg_obj);
      PUTBACK;
   }
}
#line 521 "/builddir/build/BUILD/polymake-4.4/build.x86_64/perlx/5.32.1/x86_64-linux-thread-multi/UserSettings.cc"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Polymake__Core__UserSettings); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Polymake__Core__UserSettings)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Polymake::Core::UserSettings::add_change_monitor", XS_Polymake__Core__UserSettings_add_change_monitor);
        newXS_deffile("Polymake::Core::UserSettings::drop_change_monitor", XS_Polymake__Core__UserSettings_drop_change_monitor);
        newXS_deffile("Polymake::Core::UserSettings::get_item", XS_Polymake__Core__UserSettings_get_item);

    /* Initialisation Section */

#line 325 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/UserSettings.xxs"
{
   HV* item_flags_stash = get_named_stash(aTHX_ "Polymake::Core::UserSettings::Item::Flags");
   Item_custom_flag = get_named_constant(aTHX_ item_flags_stash, "is_custom");
   Item_changed_flag = get_named_constant(aTHX_ item_flags_stash, "is_changed");
   Item_flags_index = CvDEPTH(get_cv("Polymake::Core::UserSettings::Item::flags", false));
   Settings_changed_index = CvDEPTH(get_cv("Polymake::Core::UserSettings::changed", false));
}

#line 570 "/builddir/build/BUILD/polymake-4.4/build.x86_64/perlx/5.32.1/x86_64-linux-thread-multi/UserSettings.cc"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

